//Definim els pins de cada component
#define trigPin 3
#define echoPin 2
#include <Servo.h> //inclou la biblioteca Servo perquè les seves funcions puguin utilitzar-se per controlar un motor Servo.
#define led1 8
#define led2 9
#define led3 10
#define led4 11

Servo servo;
int pos = 45; //definim la posició inicial del servo a 45º 

void setup() {
Serial.begin (9600);       //Inicialitzar els pins RX i Tx perquè puguin ser usats com a port serial
pinMode(trigPin, OUTPUT); 
pinMode(echoPin, INPUT); //Configura el pin especificat perquè es comporti com una entrada o una sortida
pinMode(led1, OUTPUT);
pinMode(led2, OUTPUT);
pinMode(led3, OUTPUT);
pinMode(led4, OUTPUT);


servo.attach(4);           //Conecta una variable Servo al pin asignat
}

void loop() {
long duration, distance;
digitalWrite(trigPin, LOW); // para generar un pulso limpio ponemos a LOW 2us
delayMicroseconds(2);
digitalWrite(trigPin, HIGH);  //generamos Trigger (disparo) de 10us
delayMicroseconds(10);
digitalWrite(trigPin, LOW); 
duration = pulseIn(echoPin, HIGH);  //Llegeix l'echoPin, retorna el temps de viatge de l'ona sonora en microsegons
distance = duration * 0.034 / 2;  // Velocitat de l'ona sonora dividida per 2 (anar i tornar)

if (distance < 12) {
servo.write(0); //Es mou el servo de 45º a 90º si el sensor detecta que esta a menys de 12cm
digitalWrite(led1, HIGH); //S'encenen tots els leds conectats si detecta la funcio anterior
digitalWrite(led2, HIGH);
digitalWrite(led3, HIGH);
digitalWrite(led4, HIGH);

}
else {
servo.write(90); //Escribe un valor en el servo, controlando el eje en consecuencia. Establecerá el ángulo del eje (en grados), moviendo el eje a esa orientación.
digitalWrite(led1, LOW);
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
digitalWrite(led4, LOW);

}

delay(500);
}